// tabs.js


function buildTabs() {
    var x = BufferList.list.length;
    var tabBar = document.getElementById('tab-bar');
    var tabContainer = document.getElementById('tabs-container');
    var tabBox = document.createElement('hbox');

    var throwaway = tabBar.removeChild(tabContainer);
    tabBox.setAttribute('id','tabs-container');
    tabBox.setAttribute('flex','1');
    tabBar.appendChild(tabBox);

    for (x=0; x < BufferList.list.length; x++) {
        var tempBuffer = bufferList.getBuffer(x);
        addTabLogic( tempBuffer.getInput(), x );
    }

    focusTab(BufferList.currentBuffer);
}


function addTab(path) {
    addTabLogic(path);
    focusTab(BufferList.currentBuffer);
}


function addTabLogic(path,index) {
    var isWindows = false;
    if (navigator.platform == "Win32") {
       isWindows = true;
    }
    if (path == null) {
        path = inputFile.value;
    }
    if (index == null) {
        index = BufferList.list.length-1;
    }
    if (path == "") {
        path = "Untitled";
    }
    var x = index;
    var tabBar = document.getElementById('tabs-container');
    var tab = document.createElement('label');
    var title = x + " " + leaf(path);
    var tooltip = x + " " + truncate(path);

    if (title == "") {
        title = x+ ' Untitled';
        tooltip = x+ ' Untitled';
    }
 
    tab.setAttribute('value', title);
    tab.setAttribute('tooltiptext',tooltip);
    tab.setAttribute('onclick',"if (event.button == 0) {this.setAttribute('selected','true');focusTab("+x+");doBuff("+x+")}");
    tab.setAttribute('id','tab-item'+x);
    tab.setAttribute('index',x);
    tab.setAttribute('context','tab-context');
    tab.setAttribute('flex','1');
    tab.setAttribute('class','tab');
    if (!isWindows) {
        tab.setAttribute('style','font-size:12px !important');
    }
    tab.setAttribute('onmouseover',"this.setAttribute('class','tabOver')");
    tab.setAttribute('onmouseout',"this.setAttribute('class','tab')");
    tab.setAttribute('selected','true');
    tabBar.appendChild(tab);
    dump("Tab added in addTab()\n");
}


function setTabTitle(path) {
   if (path == null) {
       path = inputFile.value;
   }

   var title = BufferList.currentBuffer + " " + leaf(path);
   var tab = document.getElementById('tab-item'+BufferList.currentBuffer);
   tab.setAttribute('value', title);
   tab.setAttribute('tooltiptext', path);
}


function focusTab(which) {
    tabBar = document.getElementById('tabs-container');

    for (x=0; x < BufferList.list.length; x++) {
        var item = document.getElementById('tab-item'+x);
        item.setAttribute('selected','false');
    }
    item = document.getElementById('tab-item'+which);
    item.setAttribute('selected','true');
}


function removeTab(thisTab) {
    removeMenuBufferItem(thisTab);
    buildTabs();
}
